VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ISysTrayItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum MouseButton
    vbNone = 0&
    vbLeftButton = 1&
    vbRightButton = 2&
    vbMiddleButton = 4&
End Enum

Public Enum MouseAction
    maMove = 0&
    maDown = 1&
    maUp = 2&
    maDblClk = 4&
End Enum

Private mblnInitialized     As Boolean
Private mlngHwnd            As Long
Private mlngHicon           As Long
Private mstrPopUpMessage    As String
Private mlngCallBackID      As Long
Private mlngPrevProcID      As Long
Private midIconData         As IconData

Friend Property Let hWnd(ByVal lngHwnd As Long)
    mlngHwnd = lngHwnd
End Property

Friend Property Get hWnd() As Long
    hWnd = mlngHwnd
End Property

Friend Property Let hIcon(ByVal lngHicon As Long)
    mlngHicon = lngHicon
End Property

Friend Property Get hIcon() As Long
    hIcon = mlngHicon
End Property

Friend Property Let PopUpText(ByVal strPopUpText As String)
    mstrPopUpMessage = Replace(Left$(strPopUpText, 63), Chr(0), vbNullString) & Chr(0)
End Property

Friend Property Get PopUpText() As String
    PopUpText = Replace(mstrPopUpMessage, Chr(0), vbNullString)
End Property

Friend Function IconToTray(Optional ByVal lngHwnd As Long, Optional ByVal lngHicon As Long, Optional ByVal strPopUpText As String) As Boolean
    If Not SetPrivateData(lngHwnd, lngHicon, strPopUpText) Then Exit Function
    mblnInitialized = SubClass(mlngHwnd, saInit)
    If Not mblnInitialized Then Exit Function
    IconToTray = SysTrayProc(iaAdd, midIconData) = 1
End Function

Friend Function IconFromTray(Optional ByVal lngHwnd As Long) As Boolean
    If Not mblnInitialized Then Exit Function
    IconFromTray = SysTrayProc(iaDelete, midIconData) = 1
End Function

Friend Function IconModifyTray(Optional ByVal lngHwnd As Long, Optional ByVal lngHicon As Long, Optional ByVal strPopUpText As String) As Boolean
    If Not mblnInitialized Then Exit Function
    If Not SetPrivateData(lngHwnd, lngHicon, strPopUpText) Then Exit Function
    IconModifyTray = SysTrayProc(iaModify, midIconData) = 1
End Function

Friend Property Let CallBackID(ByVal lngCallBackID As Long)
    mlngCallBackID = lngCallBackID
End Property

Friend Property Get CallBackID() As Long
    CallBackID = mlngCallBackID
End Property

Friend Property Let PrevProcID(ByVal lngPrevProcID As Long)
    mlngPrevProcID = lngPrevProcID
End Property

Friend Property Get PrevProcID() As Long
    PrevProcID = mlngPrevProcID
End Property

Private Function SetPrivateData(Optional ByVal lngHwnd As Long, Optional ByVal lngHicon As Long, Optional ByVal strPopUpText As String) As Boolean
    If lngHwnd Then mlngHwnd = lngHwnd
    If lngHicon Then mlngHicon = lngHicon
    If Len(strPopUpText) Then mstrPopUpMessage = Replace(Left$(strPopUpText, 63), Chr(0), vbNullString) & Chr(0)
    If mlngHwnd = 0 Or mlngHicon = 0 Then Exit Function
    With midIconData
        .idCallBackID = mlngCallBackID
        .idFlags = imIcon Or imHint Or imCallback
        .idHwnd = mlngHwnd
        .idIcon = mlngHicon
        .idID = APP_ID
        .idTip = mstrPopUpMessage
    End With
    SetPrivateData = True
End Function

Friend Sub ForwardMessage(ByVal mbButton As MouseButton, ByVal maEvent As MouseAction)
    Dim blnCancel               As Boolean
    
    Static sblnDblClick         As Boolean
    
    RaiseEvent MouseEvent(hWnd, mbButton, maEvent, blnCancel)
    
    If blnCancel Then Exit Sub
    
    Set objSysTrayItem = mobjSysTrayItems(hWnd)
    If objSysTrayItem Is Nothing Then Exit Sub
    Select Case mbButton
        Case vbNone:
        Case vbLeftButton:
        Case vbRightButton:
        Case vbMiddleButton:
    End Select
    Select Case maEvent
        Case maDblClk: sblnDblClick = True
        Case maDown:
        Case maUp:
        Case maMove:
    End Select
    If Not ((mbButton = vbNone And maEvent = maMove) Or (maEvent = maUp And sblnDblClick)) Then
    '   create a proc so that we can auto manage the iconified window
    End If
    If (maEvent = maUp And sblnDblClick) Then
        sblnDblClick = False
    End If
End Sub

Private Sub Class_Terminate()
    SubClass mlngHwnd, saDestroy
    IconFromTray
    ShowWindow mlngHwnd, daRestore
End Sub
