Attribute VB_Name = "basMain"
Option Explicit

Private Const WS_CHILD = &H40000000
Private Const GWL_WNDPROC = &HFFFC

Private Type CREATESTRUCT
    lpCreateParams  As Long
    hInstance       As Long
    hMenu           As Long
    hWndParent      As Long
    cy              As Long
    cx              As Long
    y               As Long
    x               As Long
    style           As Long
    lpszName        As String
    lpszClass       As String
    ExStyle         As Long
End Type

Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long
Private Declare Function RegisterShellHook Lib "Shell32" Alias "#181" (ByVal hWnd As Long, ByVal nAction As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private mlngHwnd        As Long
Private mlngMsgID       As Long
Private mlngPrevProcID  As Long

Public pobjWindowMaster As IWindowMaster

Public Function SetWindowMaster(Optional ByVal blnCreate As Boolean = True) As Boolean
    Dim CS              As CREATESTRUCT
    If blnCreate Then
        mlngHwnd = CreateWindowEx(0&, _
                                  "STATIC", _
                                  "IWindowMaster", _
                                  0&, _
                                  0&, _
                                  0&, _
                                  0&, _
                                  0&, _
                                  0&, _
                                  0&, _
                                  0&, _
                                  0&)
        If mlngHwnd = 0 Then Exit Function
        If Not RegisterWindowMaster Then Exit Function
    Else
        RegisterWindowMaster False
        DestroyWindow mlngHwnd
    End If
    SetWindowMaster = True
End Function

Private Function RegisterWindowMaster(Optional ByVal blnRegister As Boolean = True) As Boolean
    Dim blnIsRegistered     As Boolean
    If blnRegister Then
        mlngMsgID = RegisterWindowMessage(ByVal "SHELLHOOK")
        blnIsRegistered = mlngMsgID
        If Not blnIsRegistered Then Exit Function
        RegisterShellHook mlngHwnd, 1&
        mlngPrevProcID = SetWindowLong(mlngHwnd, GWL_WNDPROC, AddressOf Intercept)
        blnIsRegistered = mlngPrevProcID
    Else
        RegisterShellHook mlngHwnd, 0&
        SetWindowLong mlngHwnd, GWL_WNDPROC, mlngPrevProcID
        blnIsRegistered = True
    End If
    RegisterWindowMaster = blnIsRegistered
End Function

Public Function Intercept(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    If uMsg = mlngMsgID Then
        If wParam = wmWindowCreated Or wParam = wmWindowDestroyed Then
            pobjWindowMaster.WindowReceived lParam, wParam
        End If
    Else
        Intercept = CallWindowProc(mlngPrevProcID, hWnd, uMsg, wParam, lParam)
    End If
End Function
